## dlt-daemon 3.0.0

=== CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright(C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License(MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

# Set minimum Cmake version and setup policy behavior
cmake_minimum_required(VERSION 3.13...4.0)
project(automotive-dlt VERSION 3.0.1)


mark_as_advanced(CMAKE_BACKWARDS_COMPATIBILITY)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

include(GNUInstallDirs)
# Set version parameters
set(DLT_VERSION_STATE STABLE)

execute_process(COMMAND git describe --tags WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE DLT_REVISION
    ERROR_VARIABLE GIT_ERROR
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_STRIP_TRAILING_WHITESPACE)
if(DLT_REVISION MATCHES "^$")
    set(PRINT_REVISION "Git revision unavailable")
else(DLT_REVISION MATCHES "")
    string(REPLACE "-" "_" DLT_REVISION ${DLT_REVISION})
    set(PRINT_REVISION ${DLT_REVISION})
endif()

# set default build type, if not defined by user
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
                         "Choose build type: Debug, Release, RelWithDebInfo, MinSizeRel."
                         FORCE)
    message(STATUS "Build type not defined. Using default build type 'RelWithDebInfo'.")
endif()

include(CMakeDependentOption)

# Set of indiviual options
option(BUILD_SHARED_LIBS "Set to OFF to build static libraries"                                                      ON)
option(WITH_SYSTEMD "Set to ON to create unit files and systemd check on dlt-daemon startup"                         OFF)
option(WITH_SYSTEMD_WATCHDOG "Set to ON to use the systemd watchdog in dlt-daemon"                                   OFF)
option(WITH_SYSTEMD_WATCHDOG_ENFORCE_MSG_RX "Set to ON to trigger systemd watchdog of dlt-daemon only
                                             when a message was received since the last trigger"                     OFF)
option(WITH_SYSTEMD_WATCHDOG_ENFORCE_MSG_RX_DLT_SYSTEM "Set to ON to trigger systemd watchdog of dlt-system
                                                        only when a message was received since the last trigger"     OFF)
option(WITH_SYSTEMD_JOURNAL "Set to ON to use the systemd journal in dlt-system"                                     OFF)
option(WITH_SYSTEMD_SOCKET_ACTIVATION "Set to ON to use systemd socket activation"                                   OFF)
option(WITH_DOC "Set to ON to build documentation target"                                                            OFF)
option(WITH_MAN "Set to ON to build man pages"                                                                       OFF)
option(WITH_CHECK_CONFIG_FILE "Set to ON to create a configure file of CheckIncludeFiles, CheckFunctionExists"       OFF)
option(WITH_TESTSCRIPTS "Set to ON to run CMakeLists.txt in testscripts"                                             OFF)
option(WITH_GPROF "Set -pg to compile flags"                                                                         OFF)
option(WITH_DLTTEST "Set to ON to build with modifications to test User-Daemon communication with corrupt messages"  OFF)
option(WITH_DLT_SHM_ENABLE "EXPERIMENTAL! Set to ON to use shared memory as IPC. EXPERIMENTAL!"                      OFF)
option(WITH_DLT_ADAPTOR "Set to ON to build src/adaptor binaries"                                                    OFF)
option(WITH_DLT_ADAPTOR_STDIN "Set to ON to build src/adaptor/stdin binaries"                                        OFF)
option(WITH_DLT_ADAPTOR_UDP "Set to ON to build src/adaptor/udp binaries"                                            OFF)
option(WITH_DLT_CONSOLE "Set to ON to build src/console binaries"                                                    ON)
option(WITH_DLT_CONSOLE_WO_CTRL "Set to ON not to build control commands under src/console"                          OFF)
option(WITH_DLT_CONSOLE_WO_SBTM "Set to ON not to build dlt-sortbytimestamp under src/console"                       OFF)
option(WITH_DLT_CONSOLE_RECEIVE "Set to OFF to skip building dlt_receive"                                            ON)
option(WITH_DLT_CONSOLE_CONVERT "Set to OFF to skip building dlt_convert"                                            ON)
option(WITH_DLT_CONSOLE_CONTROL "Set to OFF to skip building dlt_control"                                            ON)
option(WITH_DLT_CONSOLE_PASSIVE_NODE_CTRL "Set to OFF to skip building dlt_passive_node_ctrl"                        ON)

option(WITH_DLT_EXAMPLES "Set to ON to build src/examples binaries"                                                  ON)
option(WITH_DLT_FILETRANSFER "Set to ON to build dlt-system with filetransfer support"                               OFF)
option(WITH_DLT_SYSTEM "Set to ON to build src/system binaries"                                                      OFF)
option(WITH_DLT_DBUS "Set to ON to build src/dbus binaries"                                                          OFF)
option(WITH_DLT_DEBUGGERS "Set to ON to enable debug symbols, AddressSanitizer, and Valgrind support"                OFF)
option(WITH_DLT_TESTS "Set to ON to build src/test binaries"                                                         ON)
option(WITH_DLT_UNIT_TESTS "Set to ON to build gtest framework and tests/binaries"                                   OFF)
cmake_dependent_option(WITH_DLT_INSTALLED_TESTS "Set to ON to install tests/binaries"                                OFF WITH_DLT_UNIT_TESTS OFF)
option(WITH_DLT_COVERAGE "Set to ON to generate coverage report for dlt-daemon source code"                          OFF)
option(BUILD_GMOCK "Set to ON to enable gmock build"                                                                 OFF)
option(WITH_GIT_SUBMODULE "Set to ON to update submodules during build"                                              OFF)
option(WITH_DLT_QNX_SYSTEM "Set to ON to build QNX system binary dlt-qnx-system"                                     OFF)
option(WITH_DLT_FILE_LOGGING_SYSLOG_FALLBACK "Set to ON to enable fallback to syslog if dlt logging to file fails"   OFF)
option(WITH_DLT_NETWORK_TRACE "Set to ON to enable network trace (if message queue is supported)"                    ON)
option(WITH_DLT_LOG_LEVEL_APP_CONFIG "Set to ON to enable default log levels based on application ids"               OFF)
option(WITH_DLT_TRACE_LOAD_CTRL "Set to ON to enable trace load control in libdlt and dlt-daemon"                    OFF)

set(DLT_IPC "FIFO"
    CACHE STRING "UNIX_SOCKET,FIFO")
set(DLT_USER "covesa"
    CACHE STRING "Set user for process not run as root")
set(DLT_QNX_SLOG_ADAPTER_WAIT_BUFFER_TIMEOUT_MS "100"
    CACHE STRING "Timeout in milliseconds to wait before messages are dropped when input buffer is full")

option(WITH_DLT_PKGCONFIG "Set to ON to generate pkgconfig .pc files"                                                ON)
option(WITH_DLT_CXX11_EXT "Set to ON to build C++11 extensions"                                                      OFF)
option(WITH_DLT_COREDUMPHANDLER "EXPERIMENTAL! Set to ON to build src/core_dump_handler binaries. EXPERIMENTAL"      OFF)
option(WITH_DLT_LOGSTORAGE_CTRL_UDEV "PROTOTYPE! Set to ON to build logstorage control with udev support"            OFF)
option(WITH_DLT_LOGSTORAGE_GZIP "Set to ON to build logstorage control with gzip compression support"                OFF)
option(WITH_DLT_USE_IPv6 "Set to ON for IPv6 support"                                                                ON)
option(WITH_DLT_KPI "Set to ON to build src/kpi binaries"                                                            OFF)
option(WITH_DLT_FATAL_LOG_TRAP "Set to ON to enable DLT_LOG_FATAL trap(trigger segv inside dlt-user library)"        OFF)
option(WITH_UDP_CONNECTION "Set to ON to enable dlt UDP multicast SUPPORT"                                           OFF)
option(WITH_LIB_SHORT_VERSION "Set to ON to build library with only major number in version"                         OFF)
option(WITH_DLT_DISABLE_MACRO "Set to ON to build code without Macro interface support"                              OFF)
option(WITH_LEGACY_INCLUDE_PATH "Set to ON to add <prefix>/dlt to include paths
                                 for the CMake config file, in addition to only <prefix>"                            ON)
option(WITH_EXTENDED_FILTERING "Set to OFF to build without extended filtering.
                                Json filter only supports Linux based system with json-c and QNX"                    OFF)

option(WITH_DLT_DAEMON_VSOCK_IPC "Set to ON to enable VSOCK support in daemon"                                       OFF)
option(WITH_DLT_LIB_VSOCK_IPC "Set to ON to enable VSOCK support in library (DLT_IPC is not used in library)"        OFF)

set(DLT_VSOCK_PORT "13490"
    CACHE STRING "VSOCK port number for logging traffic.")
set(DLT_WRITEV_TIMEOUT_MS "1000"
    CACHE STRING "Set millisecond timeout for writev to prevent blocking indefinitely")

# RPM settings
set(COVESA_RPM_RELEASE "1")  # ${DLT_REVISION}
set(LICENSE "Mozilla Public License Version 2.0")

# Build, project and include settings
find_package(Threads REQUIRED)
if(WITH_DLT_LOGSTORAGE_GZIP)
    find_package(ZLIB 1.2.9 REQUIRED)
elseif(WITH_DLT_COREDUMPHANDLER OR WITH_DLT_FILETRANSFER)
    find_package(ZLIB REQUIRED)
else()
    set(ZLIB_LIBRARY "")
endif()

if(WITH_DLT_DBUS)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(DBUS REQUIRED dbus-1)
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}/include/dlt
    ${PROJECT_SOURCE_DIR}/include/dlt
    ${PROJECT_SOURCE_DIR}/src/shared
    ${PROJECT_SOURCE_DIR}/src/core_dump_handler
    ${PROJECT_SOURCE_DIR}/src/offlinelogstorage
    ${PROJECT_SOURCE_DIR}/src/lib
    ${PROJECT_SOURCE_DIR}/src/daemon
    ${PROJECT_SOURCE_DIR}/src/console
    ${PROJECT_SOURCE_DIR}/src/gateway
    ${PROJECT_SOURCE_DIR}/systemd/3rdparty
)

if(WITH_DLT_DEBUGGERS)
    message(STATUS "WITH_DLT_DEBUGGERS is ON: Enabling -g3, -O0, AddressSanitizer, and Valgrind compatibility.")
    if (CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g3 -O0 -fsanitize=address")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g3 -O0 -fsanitize=address")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
    endif()
    set(ENV{ASAN_OPTIONS} "detect_leaks=1")
    message(STATUS "AddressSanitizer enabled: run your binaries normally.")
    message(STATUS "If a memory error occurs, AddressSanitizer will print a detailed error report to the terminal, including the type of bug, stack trace, and location.")
    message(STATUS "Leak detection is enabled by default (ASAN_OPTIONS=detect_leaks=1). See https://clang.llvm.org/docs/AddressSanitizer.html for more info.")
    message(STATUS "You can also run the binaries with Valgrind: valgrind ./your_binary")
endif()

add_definitions(-D_GNU_SOURCE)
add_definitions(-DDLT_WRITEV_TIMEOUT_MS=${DLT_WRITEV_TIMEOUT_MS})
add_definitions(-DDLT_QNX_SLOG_ADAPTER_WAIT_BUFFER_TIMEOUT_MS=${DLT_QNX_SLOG_ADAPTER_WAIT_BUFFER_TIMEOUT_MS})

if(NOT DLT_IPC STREQUAL "UNIX_SOCKET" AND NOT DLT_IPC STREQUAL "FIFO")
    message(FATAL_ERROR "${DLT_IPC} is not a valid value for DLT_IPC")
endif()

add_definitions(-DDLT_DAEMON_USE_${DLT_IPC}_IPC)

if(WITH_DLT_DAEMON_VSOCK_IPC)
    add_definitions(-DDLT_DAEMON_VSOCK_IPC_ENABLE)
endif()

if(NOT WITH_DLT_LIB_VSOCK_IPC)
    add_definitions(-DDLT_LIB_USE_${DLT_IPC}_IPC)
else()
    add_definitions(-DDLT_LIB_USE_VSOCK_IPC)
endif()

if(WITH_DLT_DAEMON_VSOCK_IPC OR WITH_DLT_LIB_VSOCK_IPC)
    add_definitions(-DDLT_VSOCK_PORT=${DLT_VSOCK_PORT})
endif()

if(NOT DLT_USER_IPC_PATH)
    set(DLT_USER_IPC_PATH "/tmp")
endif()

add_definitions(-DDLT_USER_IPC_PATH="${DLT_USER_IPC_PATH}")

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...4.0)

# Add all example subdirectories
add_subdirectory(example1)
add_subdirectory(example2)
add_subdirectory(example3)
add_subdirectory(example4)
add_subdirectory(example1_v2)
add_subdirectory(example2_v2)
add_subdirectory(example3_v2)
add_subdirectory(example4_v2)

=== tests/CMakeLists.txt ===
# Setup testing
enable_testing()
SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -isystem ${gtest_SOURCE_DIR}/include")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -isystem ${gtest_SOURCE_DIR}/include -std=gnu++0x")

configure_file(${PROJECT_SOURCE_DIR}/tests/testfile.dlt ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/tests/testfile-v2.dlt ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/tests/testfilter.txt ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/tests/testfile_filetransfer.txt ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/util/gtest_dlt_actuator.py ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/tests/gtest_dlt_teardown.sh ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/tests/test_dlt.conf ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)

if(WITH_DLT_INSTALLED_TESTS)
    set(DLT_TEST_DIR ${CMAKE_INSTALL_BINDIR}/dlt_tests)
    install(FILES testfile.dlt testfilter.txt testfile_filetransfer.txt DESTINATION ${DLT_TEST_DIR})
endif(WITH_DLT_INSTALLED_TESTS)

if("${GTEST_BOTH_LIBRARIES}" STREQUAL "")
    set(GTEST_LIBS gtest gtest_main)
    set(GTEST_LIBS ${GTEST_LIBS} CACHE STRING "Gtest libraries")
else()
    set(GTEST_LIBS ${GTEST_BOTH_LIBRARIES})
endif()

if("${CMAKE_SYSTEM_NAME}" MATCHES "Linux|CYGWIN")
    set(LIBRARIES "")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "QNX")
    set(LIBRARIES regex)
else()
    set(LIBRARIES socket)
endif()
if(WITH_SYSTEMD)
  set(SYSTEMD_LIBS systemd)
endif(WITH_SYSTEMD)
set(DLT_LIBRARIES dlt ${GTEST_LIBS} ${LIBRARIES})
set(DLT_DAEMON_LIBRARIES dlt_daemon ${GTEST_LIBS} ${LIBRARIES} ${SYSTEMD_LIBS})
set(DLT_CONTROL_LIBRARIES dlt dlt_control_common_lib ${GTEST_LIBS})

# Receiver used for QTs. add_test() is not required
add_executable(dlt_test_receiver dlt_test_receiver.c)
target_link_libraries(dlt_test_receiver ${DLT_LIBRARIES})

# Prepare string for testing command sequence
set(CMD_TEST_INIT "TEST_FAILED=0")
set(CMD_SEQ_SLEEP "sleep 0.5")
string(REPLACE ";" " " TEST_ENV_SHELL "${TEST_ENV}")
set(CMD_SEQ_TEARDOWN "env ${TEST_ENV_SHELL} sh ${CMAKE_CURRENT_BINARY_DIR}/gtest_dlt_teardown.sh || true")
set(CMD_SEQ_EXIT "exit $TEST_FAILED")

string(CONCAT CMD_SEQ "${CMD_SEQ_SLEEP};"
                      "${CMD_SEQ_TEARDOWN};"
                      "${CMD_SEQ_EXIT}")

# Prepare string for setting environment variables
set(TEST_ENV_PATH "PATH=$<TARGET_FILE_DIR:dlt-daemon>:$ENV{PATH}")
set(TEST_ENV_DAEMON "DLT_UT_DAEMON_PATH=$<TARGET_FILE:dlt-daemon>")
set(TEST_ENV_DAEMON_CONFIG "DLT_UT_CONFIG_PATH=$<TARGET_FILE_DIR:dlt-daemon>/dlt.conf")
set(TEST_ENV_LO_IPv6 "DLT_IPv6_LO=::1")
if(WITH_DLT_USE_IPv6)
    string(CONCAT TEST_ENV "${TEST_ENV_PATH};"
                           "${TEST_ENV_DAEMON};"
                           "${TEST_ENV_LO_IPv6}")
else()
    string(CONCAT TEST_ENV "${TEST_ENV_PATH};"
                           "${TEST_ENV_DAEMON}")
endif()
if(WITH_QEMU_AARCH64_GTEST)
    set(TEST_ENV_QEMU "QEMU=$ENV{OECORE_NATIVE_SYSROOT}/usr/bin/qemu-aarch64")
    string(CONCAT TEST_ENV_SDK "${TEST_ENV};"
                               "${TEST_ENV_QEMU}")
endif()
# Set timeout
set(seconds 5)
####################
# DLT library tests
####################
set(TARGET_LIST gtest_dlt_common
                gtest_dlt_user
                gtest_dlt_daemon
                gtest_dlt_daemon_common
                gtest_dlt_common_v2
                gtest_dlt_user_v2
                gtest_dlt_daemon_v2
                gtest_dlt_daemon_common_v2
                dlt_env_ll_unit_test)

foreach(target IN LISTS TARGET_LIST)
    set(target_SRCS ${target})
    if(${target} STREQUAL "dlt_env_ll_unit_test")
        set(target_SRCS ${target}.cpp)
    elseif(${target} STREQUAL "gtest_dlt_daemon_common")
        set(target_SRCS ${target}.cpp ${PROJECT_SOURCE_DIR}/src/daemon/dlt_daemon_common.c)
    elseif(${target} STREQUAL "gtest_dlt_daemon_common_v2")
        set(target_SRCS ${target}.cpp ${PROJECT_SOURCE_DIR}/src/daemon/dlt_daemon_common.c)
    elseif(${target} STREQUAL "gtest_dlt_daemon")
        set(target_SRCS ${target}.cpp
            ../src/daemon/dlt-daemon.c
            ../src/daemon/dlt_daemon_client.c
            ../src/daemon/dlt_daemon_common.c
            ../src/daemon/dlt_daemon_connection.c
            ../src/daemon/dlt_daemon_event_handler.c
            ../src/daemon/dlt_daemon_offline_logstorage.c
            ../src/daemon/dlt_daemon_serial.c
            ../src/daemon/dlt_daemon_socket.c
            ../src/daemon/dlt_daemon_unix_socket.c
            ../src/gateway/dlt_gateway.c
            ../src/offlinelogstorage/dlt_offline_logstorage_behavior.c
            ../src/offlinelogstorage/dlt_offline_logstorage.c
            ../src/shared/dlt_config_file_parser.c
            ../src/shared/dlt_offline_trace.c
        )
        add_compile_definitions(${target} DLT_DAEMON_UNIT_TESTS_NO_MAIN)
    elseif(${target} STREQUAL "gtest_dlt_daemon_v2")
        set(target_SRCS ${target}.cpp
            ../src/daemon/dlt-daemon.c
            ../src/daemon/dlt_daemon_client.c
            ../src/daemon/dlt_daemon_common.c
            ../src/daemon/dlt_daemon_connection.c
            ../src/daemon/dlt_daemon_event_handler.c
            ../src/daemon/dlt_daemon_offline_logstorage.c
            ../src/daemon/dlt_daemon_serial.c
            ../src/daemon/dlt_daemon_socket.c
            ../src/daemon/dlt_daemon_unix_socket.c
            ../src/gateway/dlt_gateway.c
            ../src/offlinelogstorage/dlt_offline_logstorage_behavior.c
            ../src/offlinelogstorage/dlt_offline_logstorage.c
            ../src/shared/dlt_config_file_parser.c
            ../src/shared/dlt_offline_trace.c
        )
        add_compile_definitions(${target} DLT_DAEMON_UNIT_TESTS_NO_MAIN)
    else()
        set(target_SRCS ${target}.cpp)
    endif()

    add_executable(${target} ${target_SRCS})
    target_link_libraries(${target} ${DLT_LIBRARIES})
    if(EXISTS ${PROJECT_SOURCE_DIR}/tests/${target}.sh)
        configure_file(${PROJECT_SOURCE_DIR}/tests/${target}.sh ${PROJECT_BINARY_DIR}/tests COPYONLY)
        set(CMD_SEQ_SETUP "sh $<TARGET_FILE:${target}>.sh")
        if(WITH_QEMU_AARCH64_GTEST)
            set(CMD_SEQ_BOOL "qemu-aarch64 $<TARGET_FILE:${target}> || TEST_FAILED=1")
        else()
            set(CMD_SEQ_BOOL "$<TARGET_FILE:${target}> || TEST_FAILED=1")
        endif()
        add_test(NAME ${target} COMMAND /bin/sh -e -c "${CMD_SEQ_SETUP};${CMD_TEST_INIT};${CMD_SEQ_BOOL};${CMD_SEQ}")
        if(WITH_QEMU_AARCH64_GTEST)
            set_tests_properties(${target} PROPERTIES ENVIRONMENT "${TEST_ENV_SDK}")
        else()
            set_tests_properties(${target} PROPERTIES ENVIRONMENT "${TEST_ENV}")
        endif()
    else()
        if(WITH_QEMU_AARCH64_GTEST)
            add_test(NAME ${target} COMMAND /bin/sh -e -c "qemu-aarch64 $<TARGET_FILE:${target}>")
        else()
            add_test(NAME ${target} COMMAND ${target})
        endif()
    endif()
endforeach()

###################
# DLT daemon tests
###################
set(TARGET_LIST gtest_dlt_daemon_gateway
                gtest_dlt_daemon_offline_log
                gtest_dlt_daemon_event_handler
                gtest_dlt_daemon_multiple_files_logging)

if(WITH_DLT_LOG_STATISTIC)
    list(APPEND TARGET_LIST gtest_dlt_daemon_statistics)
endif()

if(WITH_DLT_SHM_ENABLE)
    list(APPEND TARGET_LIST gtest_dlt_shm)
endif()

foreach(target IN LISTS TARGET_LIST)
    set(target_SRCS ${target}.cpp)
    add_executable(${target} ${target_SRCS} ${systemd_SRCS})
    target_link_libraries(${target} ${DLT_DAEMON_LIBRARIES} ${ZLIB_LIBRARY})
    if(WITH_DLT_INSTALLED_TESTS)
        install(TARGETS ${target} RUNTIME DESTINATION ${DLT_TEST_DIR})
        if(EXISTS ${PROJECT_SOURCE_DIR}/tests/${target}.sh)
            install(PROGRAMS ${target}.sh DESTINATION ${DLT_TEST_DIR})
        endif()
    endif(WITH_DLT_INSTALLED_TESTS)
    if(EXISTS ${PROJECT_SOURCE_DIR}/tests/${target}.sh)
        configure_file(${PROJECT_SOURCE_DIR}/tests/${target}.sh ${PROJECT_BINARY_DIR}/tests COPYONLY)
        set(CMD_SEQ_SETUP "sh $<TARGET_FILE:${target}>.sh")
        if(WITH_QEMU_AARCH64_GTEST)
            set(CMD_SEQ_BOOL "qemu-aarch64 $<TARGET_FILE:${target}> || TEST_FAILED=1")
        else()
            set(CMD_SEQ_BOOL "$<TARGET_FILE:${target}> || TEST_FAILED=1")
        endif()
        add_test(NAME ${target} COMMAND /bin/sh -e -c "${CMD_SEQ_SETUP};${CMD_TEST_INIT};${CMD_SEQ_BOOL};${CMD_SEQ}")
        if(WITH_QEMU_AARCH64_GTEST)
            set_tests_properties(${target} PROPERTIES ENVIRONMENT "${TEST_ENV_SDK}")
        else()
            set_tests_properties(${target} PROPERTIES ENVIRONMENT "${TEST_ENV}")
        endif()
    else()
        if(WITH_QEMU_AARCH64_GTEST)
            add_test(NAME ${target} COMMAND /bin/sh -e -c "qemu-aarch64 $<TARGET_FILE:${target}>")
        else()
            add_test(NAME ${target} COMMAND ${target})
        endif()
    endif()
    set_tests_properties(${target} PROPERTIES TIMEOUT "${seconds}")
endforeach()

#####################
# DLT control tests
#####################
if(WITH_EXTENDED_FILTERING)
    configure_file(${PROJECT_SOURCE_DIR}/tests/testfile_extended.dlt ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
    configure_file(${PROJECT_SOURCE_DIR}/tests/testfilter.json ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
    add_executable(gtest_dlt_json_filter gtest_dlt_json_filter.cpp)
    target_link_libraries(gtest_dlt_json_filter ${DLT_CONTROL_LIBRARIES})
    if(WITH_QEMU_AARCH64_GTEST)
            add_test(NAME gtest_dlt_json_filter COMMAND /bin/sh -e -c "qemu-aarch64 gtest_dlt_json_filter")
        else()
            add_test(NAME gtest_dlt_json_filter COMMAND gtest_dlt_json_filter)
        endif()
    set_tests_properties(${target} PROPERTIES TIMEOUT "${seconds}")
endif()
#####################
# DLT coverage
#####################
if(WITH_DLT_COVERAGE)
    add_custom_target(lcov
        COMMAND echo "=================== LCOV ===================="
        COMMAND rm -rf "dlt_lcov_report"
        COMMAND mkdir -p "dlt_lcov_report"
        COMMAND lcov --capture --directory "${CMAKE_CURRENT_BINARY_DIR}/../src" --output-file "dlt_lcov_report/dlt_init_coverage.info"
        COMMAND echo "-- Filtering external source files"
        COMMAND lcov --remove "dlt_lcov_report/dlt_init_coverage.info"
                     -o "dlt_lcov_report/dlt_final_coverage.info"
                     "/usr/*" "*/include/*" "*.h" "*.hpp" "*/tests/*" "*/main.cpp"
        COMMAND echo "-- Generating HTML output files"
        COMMAND genhtml "dlt_lcov_report/dlt_final_coverage.info" --output-directory "dlt_lcov_report"
        COMMAND ${CMAKE_COMMAND} -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/../dlt_lcov_report"
        COMMAND ${CMAKE_COMMAND} -E rename "${CMAKE_CURRENT_BINARY_DIR}/dlt_lcov_report" "${CMAKE_CURRENT_BINARY_DIR}/../dlt_lcov_report"
        COMMAND ${CMAKE_COMMAND} -E echo ""
        COMMAND ${CMAKE_COMMAND} -E echo "=== LCOV LIST: dlt_lcov_report ==="
        COMMAND lcov --list "${CMAKE_CURRENT_BINARY_DIR}/../dlt_lcov_report/dlt_final_coverage.info"
    )
endif()

add_subdirectory(components)

=== examples/example1/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example1 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example1_SRCS example1.c)
add_executable(dlt-example1 ${dlt_example1_SRCS})
target_link_libraries(dlt-example1 ${DLT_LIBRARIES})
set_target_properties(dlt-example1 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example1
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example1_v2/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example1 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example1_SRCS example1.c)
add_executable(dlt-example1 ${dlt_example1_SRCS})
target_link_libraries(dlt-example1 ${DLT_LIBRARIES})
set_target_properties(dlt-example1 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example1
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example2/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example2 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example2_SRCS example2.c)
add_executable(dlt-example2 ${dlt_example2_SRCS})
target_link_libraries(dlt-example2 ${DLT_LIBRARIES})
set_target_properties(dlt-example2 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example2
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example2_v2/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example2 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example2_SRCS example2.c)
add_executable(dlt-example2 ${dlt_example2_SRCS})
target_link_libraries(dlt-example2 ${DLT_LIBRARIES})
set_target_properties(dlt-example2 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example2
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example3/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example3 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example3_SRCS example3.c)
add_executable(dlt-example3 ${dlt_example3_SRCS})
target_link_libraries(dlt-example3 ${DLT_LIBRARIES})
set_target_properties(dlt-example3 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example3
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example3_v2/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example3 )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example3_SRCS example3.c)
add_executable(dlt-example3 ${dlt_example3_SRCS})
target_link_libraries(dlt-example3 ${DLT_LIBRARIES})
set_target_properties(dlt-example3 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example3
        RUNTIME DESTINATION bin
        COMPONENT base)

=== examples/example4/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

#
# DLT example implementation
#

project( automotive-dlt-example4 )

#
# set prefix
#

set( CMAKE_INSTALL_PREFIX "/usr" )

#
# find dependency packages
#

find_package(PkgConfig)
pkg_check_modules(DLT REQUIRED automotive-dlt)

#
# include directories
#

include_directories(
    ${DLT_INCLUDE_DIRS}
)

#
# build project
#

set(dlt_example4_SRCS example4.c)
add_executable(dlt-example4 ${dlt_example4_SRCS})
target_link_libraries(dlt-example4 ${DLT_LIBRARIES})
set_target_properties(dlt-example4 PROPERTIES LINKER_LANGUAGE C)

install(TARGETS dlt-example4
        RUNTIME DESTINATION bin
        COMPONENT base)

=== qnx/build/Makefile ===
LIST=OS CPU VARIANT
ifndef QRECURSE
QRECURSE=recurse.mk
ifdef QCONFIG
QRDIR=$(dir $(QCONFIG))
endif
endif
include $(QRDIR)$(QRECURSE)

=== src/console/CMakeLists.txt ===
#######
# SPDX license identifier: MPL-2.0
#
# Copyright (C) 2011-2015, BMW AG
#
# This file is part of COVESA Project DLT - Diagnostic Log and Trace.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.org/.
#######

set(dlt_control_common_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/dlt-control-common.c)
add_library(dlt_control_common_lib STATIC ${dlt_control_common_SRCS})
target_link_libraries(dlt_control_common_lib dlt ${DLT_JSON_LIBRARY})

set(TARGET_LIST "")

if (WITH_DLT_CONSOLE_RECEIVE)
    list(APPEND TARGET_LIST dlt-receive)
    list(APPEND TARGET_LIST dlt-receive-v2)
endif()

if (WITH_DLT_CONSOLE_CONVERT)
    list(APPEND TARGET_LIST dlt-convert)
endif()

if(NOT WITH_DLT_CONSOLE_WO_CTRL)
    add_subdirectory(logstorage)
    if (WITH_DLT_CONSOLE_CONTROL)
        list(APPEND TARGET_LIST dlt-control)
        list(APPEND TARGET_LIST dlt-control-v2)
    endif()
    if (WITH_DLT_CONSOLE_PASSIVE_NODE_CTRL)
        list(APPEND TARGET_LIST dlt-passive-node-ctrl)
    endif()
endif()

if(NOT WITH_DLT_CONSOLE_WO_SBTM)
    list(APPEND TARGET_LIST dlt-sortbytimestamp)
endif()

foreach(target IN LISTS TARGET_LIST)
    set(target_SRCS ${target}.c)
    add_executable(${target} ${target_SRCS})
    target_link_libraries(${target} dlt dlt_control_common_lib)
    set_target_properties(${target} PROPERTIES LINKER_LANGUAGE C)

    install(TARGETS ${target}
            RUNTIME DESTINATION bin
            COMPONENT base)
endforeach()

=== debian/changelog ===
dlt-daemon (3.0.0-4) unstable; urgency=medium

  * Ignore tests for now (Closes: #1127857)
  * Follow upstream soname bump to libdlt3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Feb 2026 11:07:45 +0100

dlt-daemon (3.0.0-3) unstable; urgency=medium

  * Ignore sign-compare for i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 21:23:30 +0100

dlt-daemon (3.0.0-2) unstable; urgency=medium

  * Also ignore shift-count-overflow for i386 32 bit time_t

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 18:31:45 +0100

dlt-daemon (3.0.0-1) unstable; urgency=medium

  * Add patch 810 and split no-errors with remaining failures
  * New upstream version 3.0.0
  * Bump std-version to 4.7.3, no changes required
  * Add tools for dltv2 protocol
  * Refresh patches for new release
  * Add patch to fix build with new release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 16:39:14 +0100

=== debian/control ===
Source: dlt-daemon
Priority: optional
Maintainer: Aigars Mahinovs <aigarius@debian.org>
Uploaders:
 Gianfranco Costamagna <locutusofborg@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen,
 libdbus-1-dev,
 libgtest-dev,
 libjson-c-dev,
 libsystemd-dev,
 pandoc,
 pkgconf,
 psmisc <!nocheck>,
 systemd-dev,
 zlib1g-dev,
Standards-Version: 4.7.3
Section: libs
Vcs-Browser: https://salsa.debian.org/debian/dlt-daemon
Vcs-Git: https://salsa.debian.org/debian/dlt-daemon.git
Homepage: https://github.com/COVESA/dlt-daemon

Package: libdlt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdlt3 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Description: Diagnostic Log and Trace (DLT) library (development)
 This component provides a log and trace interface, based on the standardised
 protocol specified in the AUTOSAR standard 4.0 DLT. This software can be used
 by COVESA components and other applications as logging facility.
 .
 DLT library is used by apps that need to log to a DLT daemon directly and by
 apps that want to read logs from DLT daemon. This package provides development
 files.

Package: libdlt3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Diagnostic Log and Trace (DLT) library
 This component provides a log and trace interface, based on the standardised
 protocol specified in the AUTOSAR standard 4.0 DLT. This software can be used
 by COVESA components and other applications as logging facility.
 .
 DLT library is used by apps that need to log to a DLT daemon directly and by
 apps that want to read logs from DLT daemon.

Package: dlt-daemon
Architecture: any
Multi-Arch: foreign
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 dlt-tools,
Description: Diagnostic Log and Trace logging daemon
 This component provides a log and trace interface, based on the standardised
 protocol specified in the AUTOSAR standard 4.0 DLT. This software can be used
 by COVESA components and other applications as logging facility.
 .
 The DLT daemon is the central component in COVESA, which gathers all logs and
 traces from the DLT user applications. The logs and traces can optionally
 be directly written to a file in the ECU. The DLT daemon forwards all logs
 and traces to a connected DLT client. The DLT client can send control
 messages to the daemon, e.g. to set individual log levels of applications
 and contexts or get the list of applications and contexts registered in the
 DLT daemon.

Package: dlt-tools
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 dlt-daemon,
Description: Diagnostic Log and Trace (DLT) (documentation)
 This component provides a log and trace interface, based on the standardised
 protocol specified in the AUTOSAR standard 4.0 DLT. This software can be used
 by COVESA components and other applications as logging facility.
 .
 This package includes tools to connect to and experiment with DLT daemon.
 Most usefully this includes 'dlt-receive' to connect to a (remote) DLT server
 and save all logs to a DLT file and 'dlt-system' that injects system logs
 into the DLT server

Package: libdlt-examples
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 dlt-daemon,
Description: Diagnostic Log and Trace (DLT) (examples)
 This component provides a log and trace interface, based on the standardised
 protocol specified in the AUTOSAR standard 4.0 DLT. This software can be used
 by COVESA components and other applications as logging facility.
 .
 This package includes example apps and test tools for DLT server.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

%:
	dh $@


override_dh_auto_configure:
	# keep disabled for now? -DDLT_IPC=UNIX_SOCKET -DWITH_SYSTEMD_SOCKET_ACTIVATION=ON
	dh_auto_configure -- \
		-DWITH_SYSTEMD=ON -DWITH_SYSTEMD_JOURNAL=ON -DWITH_SYSTEMD_WATCHDOG=ON -DWITH_MAN=ON -DWITH_DLT_ADAPTOR=ON \
		-DWITH_DLT_DBUS=ON -DWITH_DLT_SYSTEM=ON -DWITH_DLT_KPI=ON -DWITH_DLT_FILETRANSFER=ON -DWITH_UDP_CONNECTION=ON \
		-DWITH_DLT_UNIT_TESTS=ON -DWITH_EXTENDED_FILTERING=ON -DWITH_DLT_LOGSTORAGE_GZIP=ON -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
		-DDLT_USER="_dlt"

override_dh_auto_test:
	#dh_auto_test --no-parallel

execute_after_dh_auto_install:
	# they are used only for testing, and they mention /usr/local/ in source code, so they can't work anyway
	rm debian/tmp/usr/share/dlt-filetransfer/dlt-test-filetransfer-file debian/tmp/usr/share/dlt-filetransfer/dlt-test-filetransfer-image.png

override_dh_installinit:
	dh_installinit -pdlt-tools --name=dlt-system -n
	dh_installinit -pdlt-tools --name=dlt-dbus -n
	dh_installinit -n
